﻿using NGTools.Tools;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace NGTools.Pages.Z_System
{
    public partial class BUY_GN : System.Web.UI.Page
    {

        public DataTable dtFieldName = MySQLHelper.ExecuteDataTable("select * from field_name order by  ID");

        protected void Page_Load(object sender, EventArgs e)
        {
            if (  Request["action"] == "getDataGrid")
            {
                  Response.Write(getData(  Request.Form["par"]));
                  Response.End();
            }
        }




        /// <summary>
        /// 获取网格数据表格并转换成JSON
        /// 传入的参数格式是："tableName,条件字段~条件字段值
        /// </summary>
        /// <returns>JSON格式</returns>
        private string getData(string strPar)
        {
          

            string strSQL = "";
            try
            {
                strSQL = "select * from system_menu where parent_id <> 'M10' and parent_id <> 'M00' order by parent_id,showorder";
                DataTable dtTemp = MySQLHelper.ExecuteDataTable(strSQL);
                DataView dv = dtTemp.DefaultView;
                DataTable dtAllMenu = dv.ToTable(false, "ID", "Menu_ID", "Menu_Name", "MDJG", "CSJG", "BNJG");
                dtAllMenu.Columns.Add("Buy_Type", typeof(string));
                dtAllMenu.Columns.Add("Buy_Num", typeof(string));
                dv = dtAllMenu.DefaultView;
                dtTemp = dv.ToTable(false, "ID", "Menu_ID", "Menu_Name", "Buy_Type", "Buy_Num", "MDJG", "CSJG", "BNJG");
                string json = DataTableToJson(dtTemp, true);
                return json;
            }
            catch (Exception ex)
            {
                return "";
            }

        }

        /// <summary>
        /// 把DataTable数据转换为Json格式
        /// </summary>
        /// <param name="dt">传入DataTable数据</param>
        /// <returns></returns>
        public string DataTableToJson(DataTable dt, bool multRow)
        {
            StringBuilder jsonBuilder = new StringBuilder();
            jsonBuilder.Append("{\"total\"");
            jsonBuilder.Append(":");
            jsonBuilder.Append(dt.Rows.Count);
            jsonBuilder.Append(",\"rows\":");
            if (dt.Rows.Count != 1 || multRow) jsonBuilder.Append("[");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                jsonBuilder.Append("{");
                for (int j = 0; j < dt.Columns.Count; j++)
                {
                    jsonBuilder.Append("\"");
                    jsonBuilder.Append(dt.Columns[j].ColumnName);
                    jsonBuilder.Append("\":\"");
                    if (dt.Columns[j].ColumnName == "RQ")
                    {
                        jsonBuilder.Append(dt.Rows[i][j].ToString().Split(' ')[0]);
                    }
                    else
                    {
                        jsonBuilder.Append(dt.Rows[i][j].ToString());
                    }
                    jsonBuilder.Append("\",");
                }
                jsonBuilder.Remove(jsonBuilder.Length - 1, 1);
                jsonBuilder.Append("},");
            }
            if (dt.Rows.Count > 0)
            {
                jsonBuilder.Remove(jsonBuilder.Length - 1, 1);
            }
            if (dt.Rows.Count != 1 || multRow)
            { jsonBuilder.Append("],"); }
            else { jsonBuilder.Append(","); };
            jsonBuilder.Append("\"title");
            //jsonBuilder.Append(dt.TableName);
            jsonBuilder.Append("\":[");
            //这是循环获取列名称
            jsonBuilder.Append("{\"title\": \"\", \"field\":\"ck\",\"checkbox\":\"true\"},");
            for (int n = 0; n < dt.Columns.Count; n++)
            {
                jsonBuilder.Append("{");
                jsonBuilder.Append("\"field");
                jsonBuilder.Append("\":\"");
                jsonBuilder.Append(dt.Columns[n].ColumnName);
                jsonBuilder.Append("\",");
                jsonBuilder.Append("\"title");
                jsonBuilder.Append("\":\"");
                jsonBuilder.Append(getStrColumnName(dt.Columns[n].ColumnName));
                jsonBuilder.Append("\"");
                jsonBuilder.Append("},");
            }
            jsonBuilder.Remove(jsonBuilder.Length - 1, 1);
            jsonBuilder.Append("},");

            jsonBuilder.Remove(jsonBuilder.Length - 2, 2);
            jsonBuilder.Append("]");
            jsonBuilder.Append("}");
            return jsonBuilder.ToString();
        }

        private string getStrColumnName(string strName)
        {
            try
            {
                string temp = dtFieldName.Select("field_text='" + strName + "'")[0]["field_name"].ToString();
                return temp;
            }
            catch (Exception)
            {
                return "";

            }

        }
    }
}