﻿
/*
* jquery 初始化form插件，传入一个json对象，为form赋值 
* version: 1.0.0-2013.06.24
* @requires jQuery v1.5 or later
* Copyright (c) 2013
* note:  1、此方法能赋值一般所有表单，但考虑到checkbox的赋值难度，以及表单中很少用checkbox，这里不对checkbox赋值
*		  2、此插件现在只接收json赋值，不考虑到其他的来源数据
*		  3、对于特殊的textarea，比如CKEditor,kindeditor...，他们的赋值有提供不同的自带方法，这里不做统一，如果项目中有用到，不能正确赋值，请单独赋值
*/
(function ($) {
    $.fn.extend({
        initForm: function (options) {
            //默认参数
            var defaults = {
                jsonValue: "",
                isDebug: false	//是否需要调试，这个用于开发阶段，发布阶段请将设置为false，默认为false,true将会把name value打印出来
            }
            //设置参数
            var setting = $.extend({}, defaults, options);
            var form = this;
            jsonValue = setting.jsonValue;
            //如果传入的json字符串，将转为json对象
            if ($.type(setting.jsonValue) === "string") {
                jsonValue = $.parseJSON(jsonValue);
            }
            //如果传入的json对象为空，则不做任何操作
            if (!$.isEmptyObject(jsonValue)) {
                var debugInfo = "";
                $.each(jsonValue, function (key, value) {
                    //是否开启调试，开启将会把name value打印出来
                    if (setting.isDebug) {
                        alert("name:" + key + "; value:" + value);
                        debugInfo += "name:" + key + "; value:" + value + " || ";
                    }
                    var formField = form.find("[name='" + key + "']");
                    if ($.type(formField[0]) === "undefined") {
                        if (setting.isDebug) {
                            alert("can not find name:[" + key + "] in form!!!");	//没找到指定name的表单
                        }
                    } else {
                        var fieldTagName = formField[0].tagName.toLowerCase();
                        if (fieldTagName == "input") {
                            if (formField.attr("type") == "radio") {
                                $("input:radio[name='" + key + "'][value='" + value + "']").attr("checked", "checked");
                            } else {
                                formField.val(value);
                            }
                        } else if (fieldTagName == "select") {
                            //do something special
                            formField.val(value);
                            formField.val(value).selectmenu('refresh', true);

                        } else if (fieldTagName == "textarea") {
                            //do something special
                            formField.val(value);
                        } else {
                            formField.val(value);
                        }
                    }
                })
                if (setting.isDebug) {
                    alert(debugInfo);
                }
            }
            return form;	//返回对象，提供链式操作
        },
       getFormJson: function () {
        var o = {};
        var a =this.serializeArray();

        $.each(a, function () {
            if (this.name == "password") {
                //this.value = $.md5(this.value) //md5操作 
                this.value = this.value;
            }
            if (o[this.name] !== undefined) {
                if (!o[this.name].push) {
                    o[this.name] = [o[this.name]];
                }
                o[this.name].push(this.value || '');
            } else {
                o[this.name] = this.value || '';
            }
        });
        return o;
    }


    });
})(jQuery)



function sumZfM() {

    var summ = 0;
   
    if ($('#NG_C1').val() != "") { summ += parseFloat($('#NG_C1').val()) };
    if ($('#NG_N2').val() != "") { summ += parseFloat($('#NG_N2').val()) };
    if ($('#NG_CO2').val() != "") { summ += parseFloat($('#NG_CO2').val()) };
    if ($('#NG_C2').val() != "") { summ += parseFloat($('#NG_C2').val()) };
    if ($('#NG_C3').val() != "") { summ += parseFloat($('#NG_C3').val()) };
    if ($('#NG_H2O').val() != "") { summ += parseFloat($('#NG_H2O').val()) };
    if ($('#NG_H2S').val() != "") { summ += parseFloat($('#NG_H2S').val()) };
    if ($('#NG_H2').val() != "") { summ += parseFloat($('#NG_H2').val()) };
    if ($('#NG_CO').val() != "") { summ += parseFloat($('#NG_CO').val()) };
    if ($('#NG_O2').val() != "") { summ += parseFloat($('#NG_O2').val()) };
    if ($('#NG_iC4').val() != "") { summ += parseFloat($('#NG_iC4').val()) };
    if ($('#NG_nC4').val() != "") { summ += parseFloat($('#NG_nC4').val()) };
    if ($('#NG_iC5').val() != "") { summ += parseFloat($('#NG_iC5').val()) };
    if ($('#NG_nC5').val() != "") { summ += parseFloat($('#NG_nC5').val()) };
    if ($('#NG_C6').val() != "") { summ += parseFloat($('#NG_C6').val()) };
    if ($('#NG_C7').val() != "") { summ += parseFloat($('#NG_C7').val()) };
    if ($('#NG_C8').val() != "") { summ += parseFloat($('#NG_C8').val()) };
    if ($('#NG_C9').val() != "") { summ += parseFloat($('#NG_C9').val()) };
    if ($('#NG_C10').val() != "") { summ += parseFloat($('#NG_C10').val()) };
    if ($('#NG_He').val() != "") { summ += parseFloat($('#NG_He').val()) };
    if ($('#NG_Ar').val() != "") { summ += parseFloat($('#NG_Ar').val()) };

    $('#NG_SUM').val(summ);
    return summ;
};

function strZfM() {
    var summ = "";
    summ += $('#NG_C1').val() + "_";;

    summ += $('#NG_N2').val() + "_";;
    summ += $('#NG_CO2').val() + "_";;
    summ += $('#NG_C2').val() + "_";;
    summ += $('#NG_C3').val() + "_";;
    summ += $('#NG_H2O').val() + "_";;
    summ += $('#NG_H2S').val() + "_";;
    summ += $('#NG_H2').val() + "_";;
    summ += $('#NG_CO').val() + "_";;
    summ += $('#NG_O2').val() + "_";;
    summ += $('#NG_iC4').val() + "_";;
    summ += $('#NG_nC4').val() + "_";;
    summ += $('#NG_iC5').val() + "_";;
    summ += $('#NG_nC5').val() + "_";;
    summ += $('#NG_C6').val() + "_";;
    summ += $('#NG_C7').val() + "_";;
    summ += $('#NG_C8').val() + "_";;
    summ += $('#NG_C9').val() + "_";;
    summ += $('#NG_C10').val() + "_";;
    summ += $('#NG_He').val() + "_";;
    summ += $('#NG_Ar').val() + "_";;
    return summ;
};

function copyZfM() {
    var strNGPar = "{";

    strNGPar += '"NG_C1":"' + $('#NG_C1').val() + '",';
    strNGPar += '"NG_N2":"' + $('#NG_N2').val() + '",';
    strNGPar += '"NG_CO2":"' + $('#NG_CO2').val() + '",';
    strNGPar += '"NG_C2":"' + $('#NG_C2').val() + '",';
    strNGPar += '"NG_C3":"' + $('#NG_C3').val() + '",';
    strNGPar += '"NG_H2O":"' + $('#NG_H2O').val() + '",';
    strNGPar += '"NG_H2S":"' + $('#NG_H2S').val() + '",';
    strNGPar += '"NG_H2":"' + $('#NG_H2').val() + '",';
    strNGPar += '"NG_CO":"' + $('#NG_CO').val() + '",';
    strNGPar += '"NG_O2":"' + $('#NG_O2').val() + '",';
    strNGPar += '"NG_iC4":"' + $('#NG_iC4').val() + '",';
    strNGPar += '"NG_nC4":"' + $('#NG_nC4').val() + '",';
    strNGPar += '"NG_iC5":"' + $('#NG_iC5').val() + '",';
    strNGPar += '"NG_nC5":"' + $('#NG_nC5').val() + '",';
    strNGPar += '"NG_C6":"' + $('#NG_C6').val() + '",';
    strNGPar += '"NG_C7":"' + $('#NG_C7').val() + '",';
    strNGPar += '"NG_C8":"' + $('#NG_C8').val() + '",';
    strNGPar += '"NG_C9":"' + $('#NG_C9').val() + '",';
    strNGPar += '"NG_C10":"' + $('#NG_C10').val() + '",';
    strNGPar += '"NG_He":"' + $('#NG_He').val() + '",';
    strNGPar += '"NG_Ar":"' + $('#NG_Ar').val() + '"}';

    sessionStorage.setItem("NGPar", strNGPar);

}

function pasteZfM() {

    var strNGPar = JSON.parse(sessionStorage.getItem("NGPar"));

    $('#NG_C1').val( strNGPar.NG_C1);
    $('#NG_N2').val( strNGPar.NG_N2);
    $('#NG_CO2').val( strNGPar.NG_CO2);
    $('#NG_C2').val( strNGPar.NG_C2);
    $('#NG_C3').val( strNGPar.NG_C3);
    $('#NG_H2O').val( strNGPar.NG_H2O);
    $('#NG_H2S').val( strNGPar.NG_H2S);
    $('#NG_H2').val( strNGPar.NG_H2);
    $('#NG_CO').val( strNGPar.NG_CO);
    $('#NG_O2').val( strNGPar.NG_O2);
    $('#NG_iC4').val( strNGPar.NG_iC4);
    $('#NG_nC4').val( strNGPar.NG_nC4);
    $('#NG_iC5').val( strNGPar.NG_iC5);
    $('#NG_nC5').val( strNGPar.NG_nC5);
    $('#NG_C6').val( strNGPar.NG_C6);
    $('#NG_C7').val( strNGPar.NG_C7);
    $('#NG_C8').val( strNGPar.NG_C8);
    $('#NG_C9').val( strNGPar.NG_C9);
    $('#NG_C10').val( strNGPar.NG_C10);
    $('#NG_He').val( strNGPar.NG_He);
    $('#NG_Ar').val( strNGPar.NG_Ar);

}


function ZoreM() {
    $('#NG_C1').val( 0);
    $('#NG_N2').val( 0);
    $('#NG_CO2').val( 0);
    $('#NG_C2').val( 0);
    $('#NG_C3').val( 0);
    $('#NG_H2O').val( 0);
    $('#NG_H2S').val( 0);
    $('#NG_H2').val( 0);
    $('#NG_CO').val( 0);
    $('#NG_O2').val( 0);
    $('#NG_iC4').val( 0);
    $('#NG_nC4').val( 0);
    $('#NG_iC5').val( 0);
    $('#NG_nC5').val( 0);
    $('#NG_C6').val( 0);
    $('#NG_C7').val( 0);
    $('#NG_C8').val( 0);
    $('#NG_C9').val( 0);
    $('#NG_C10').val( 0);
    $('#NG_He').val( 0);
    $('#NG_Ar').val( 0);
    $('#NG_SUM').val(0);

};


//设置次数 返回是否到期或归零
function setremainTimes(userID, menuID) {
    $.ajax({
        type: "post",
        url: "../../ASHX/getTreeCombox.ashx?action=setRemainTimes" + "&t=" + Date.parse(new Date()),
        //dataType: "json",
        data: { userID: userID, menuID: menuID },
        traditional: true,
        success: function (data) {
            //alert(data);
            if (data == "0") {
                try {
                    $('#saveBtn').prop('disabled',true).addClass("ui-disabled");

                } catch (e) {

                }
                try {
                    $('#ExportXls').prop('disabled',true).addClass("ui-disabled");

                } catch (e) {

                }

                try {
                    $('#inP').prop('disabled', 'disabled').addClass("ui-disabled");  //设置输入框为禁用

                } catch (e) {

                }
                try {
                    $('#NG_C1').prop('disabled',true).addClass("ui-disabled");  //设置输入框为禁用

                } catch (e) {

                }
            }
        }
    })
}

//设置次数 返回是否到期或归零
function getEnable(userID, menuID) {

  

    $.ajax({
        type: "post",
        url: "../../ASHX/getTreeCombox.ashx?action=getEnable" + "&t=" + Date.parse(new Date()),
        //dataType: "json",
        data: { userID: userID, menuID: menuID },
        traditional: true,
        success: function (data) {

            //alert(data);

            if (data == "0") {
                try {
                    $('#saveBtn').attr('disabled', "");

                } catch (e) {

                }
                try {
                    $('#ExportXls').prop('disabled',true).addClass("ui-disabled");

                } catch (e) {

                }
                try {
                    $('#inP').prop('disabled',true).addClass("ui-disabled");  //设置输入框为禁用

                } catch (e) {

                }
                try {
                    $('#NG_C1').prop('disabled',true).addClass("ui-disabled");  //设置输入框为禁用

                } catch (e) {

                }
            }
        }
    })
    return "";
}